package hu.bme.mit.books.graphiti.editor;

import hu.bme.mit.books.graphiti.editor.features.AddAuthorBookConnectionFeature;
import hu.bme.mit.books.graphiti.editor.features.AddAuthorFeature;
import hu.bme.mit.books.graphiti.editor.features.AddBookFeature;
import hu.bme.mit.books.graphiti.editor.features.AuthorDirectEditingFeature;
import hu.bme.mit.books.graphiti.editor.features.BookDirectEditingFeature;
import hu.bme.mit.books.graphiti.editor.features.AuthorUpdateFeature;
import hu.bme.mit.books.graphiti.editor.features.BookLayoutFeature;
import hu.bme.mit.books.graphiti.editor.features.BookUpdateFeature;
import hu.bme.mit.books.graphiti.editor.features.CopyFeature;
import hu.bme.mit.books.graphiti.editor.features.CreateAuthorBookConnectionFeature;
import hu.bme.mit.books.graphiti.editor.features.CreateAuthorFeature;
import hu.bme.mit.books.graphiti.editor.features.CreateBookFeature;
import hu.bme.mit.books.graphiti.editor.features.DeleteAuthorBookConnectionFeature;
import hu.bme.mit.books.graphiti.editor.features.PasteFeature;

import org.eclipse.graphiti.dt.IDiagramTypeProvider;
import org.eclipse.graphiti.features.IAddFeature;
import org.eclipse.graphiti.features.ICopyFeature;
import org.eclipse.graphiti.features.ICreateConnectionFeature;
import org.eclipse.graphiti.features.ICreateFeature;
import org.eclipse.graphiti.features.IDeleteFeature;
import org.eclipse.graphiti.features.IDirectEditingFeature;
import org.eclipse.graphiti.features.IFeature;
import org.eclipse.graphiti.features.ILayoutFeature;
import org.eclipse.graphiti.features.IPasteFeature;
import org.eclipse.graphiti.features.IRemoveFeature;
import org.eclipse.graphiti.features.IUpdateFeature;
import org.eclipse.graphiti.features.context.IAddConnectionContext;
import org.eclipse.graphiti.features.context.IAddContext;
import org.eclipse.graphiti.features.context.ICopyContext;
import org.eclipse.graphiti.features.context.IDeleteContext;
import org.eclipse.graphiti.features.context.IDirectEditingContext;
import org.eclipse.graphiti.features.context.ILayoutContext;
import org.eclipse.graphiti.features.context.IPasteContext;
import org.eclipse.graphiti.features.context.IPictogramElementContext;
import org.eclipse.graphiti.features.context.IRemoveContext;
import org.eclipse.graphiti.features.context.IUpdateContext;
import org.eclipse.graphiti.mm.pictograms.Anchor;
import org.eclipse.graphiti.mm.pictograms.Connection;
import org.eclipse.graphiti.mm.pictograms.ContainerShape;
import org.eclipse.graphiti.mm.pictograms.PictogramElement;
import org.eclipse.graphiti.ui.features.DefaultFeatureProvider;

import books.Author;
import books.Book;

public class BookDiagramFeatureProvider extends DefaultFeatureProvider {

	public BookDiagramFeatureProvider(IDiagramTypeProvider dtp) {
		super(dtp);
	}

	@Override
	public IAddFeature getAddFeature(IAddContext context) {
		if (context.getNewObject() instanceof Book) {
			return new AddBookFeature(this);
//		} else if (context.getNewObject() instanceof Author) {
//			return new AddAuthorFeature(this);
//		} else if (context instanceof IAddConnectionContext) {
//			Anchor source = ((IAddConnectionContext) context).getSourceAnchor();
//			Anchor target = ((IAddConnectionContext) context).getTargetAnchor();
//			Object sourceElement = getBusinessObjectForPictogramElement(source.getParent());
//			Object targetElement = getBusinessObjectForPictogramElement(target.getParent());
//			if (sourceElement instanceof Author && targetElement instanceof Book) {
//				return new AddAuthorBookConnectionFeature(this);
//			}
		}
		return super.getAddFeature(context);
	}

	@Override
	public ICreateFeature[] getCreateFeatures() {
		return new ICreateFeature[] { new CreateBookFeature(this)/*,
				new CreateAuthorFeature(this)*/};
	}

//	@Override
//	public IUpdateFeature getUpdateFeature(IUpdateContext context) {
//		   PictogramElement pictogramElement = context.getPictogramElement();
//		   if (pictogramElement instanceof ContainerShape) {
//		       Object bo = getBusinessObjectForPictogramElement(pictogramElement);
//		       if (bo instanceof Book) {
//		           return new BookUpdateFeature(this);
//		       } else if (bo instanceof Author) {
//		    	   return new AuthorUpdateFeature(this);
//		       }
//		   }
//		   return super.getUpdateFeature(context);
//	}
//
//	@Override
//	public ILayoutFeature getLayoutFeature(ILayoutContext context) {
//		PictogramElement pictogramElement = context.getPictogramElement();
//	    Object bo = getBusinessObjectForPictogramElement(pictogramElement);
//	    if (bo instanceof Book) {
//	        return new BookLayoutFeature(this);
//	    }
//	    return super.getLayoutFeature(context);
//	}
//
//	@Override
//	public ICreateConnectionFeature[] getCreateConnectionFeatures() {
//		return new ICreateConnectionFeature[] {
//				new CreateAuthorBookConnectionFeature(this)
//		};
//	}
//
//	@Override
//	public IFeature[] getDragAndDropFeatures(IPictogramElementContext context) {
//		return getCreateConnectionFeatures();
//	}
//
//	
//
//	@Override
//	public IDeleteFeature getDeleteFeature(IDeleteContext context) {
//		PictogramElement pe = context.getPictogramElement();
//		if (pe instanceof Connection) {
//			Connection connection = (Connection) pe;
//			Object source = getBusinessObjectForPictogramElement(connection.getStart().getParent());
//			Object target = getBusinessObjectForPictogramElement(connection.getEnd().getParent());
//			if (source instanceof Author && target instanceof Book) {
//				return new DeleteAuthorBookConnectionFeature(this);
//			}
//		}
//		return super.getDeleteFeature(context);
//	}
//
//	@Override
//	public IDirectEditingFeature getDirectEditingFeature(
//			IDirectEditingContext context) {
//	        PictogramElement pe = context.getPictogramElement();
//	        Object bo = getBusinessObjectForPictogramElement(pe);
//	        if (bo instanceof Book) {
//	            return new BookDirectEditingFeature(this);
//	        } else if (bo instanceof Author) {
//	        	return new AuthorDirectEditingFeature(this);
//	        }
//	        return super.getDirectEditingFeature(context);
//	}
//
//	@Override
//	public ICopyFeature getCopyFeature(ICopyContext context) {
//		return new CopyFeature(this);
//	}
//
//	@Override
//	public IPasteFeature getPasteFeature(IPasteContext context) {
//		return new PasteFeature(this);
//	}

}
